<template src="./template.html"></template>

<script lang="ts">
import {
  Component,
  Prop,
  Vue,
  Watch,
  getModule,
} from "nuxt-property-decorator";
import axios from "axios";
import { api } from "~/common/constaint";
import { apiErrorHandler } from "~/utils/apiHanlers";
import sitePage from "~/store/sitePage";

@Component({})
export default class OrderSuccessComponent extends Vue {
  siteInfoModule = getModule(sitePage, this.$store);

  orderCode: any = "";
  email: any = "";
  order: any = {};
  slug = "";

  beforeDestroy() {
    this.$store.commit("product/setIsDonePaypalHome", false);
  }

  mounted() {
    this.slug = this.$route.params.slug || "";
    const { order_code, email } = this.$route.query;
    if (order_code) {
      this.orderCode = `#${order_code}`;
    }
    if (email) {
      this.email = email;
    }
    if (this.orderCode) {
      this.onCheck();
    }
  }

  async onCheck() {
    try {
      this.siteInfoModule.setLoadingFullPage(true);
      this.$axios.setHeader(
        "secret",
        "RtV30HXkxzgdV3SX83XK4UuR7k2z9mtZ0Kxo1DYkHpt4CLF9gPM4u7ysa0cWIWwXqJUCSVut7gIouorFSrbVuejy5HghYdr9TQLm"
      );
      if (!this.orderCode) {
        return this.$pushNotification.error("Please enter order code");
      }
      const response = await this.$api.order.getMyOrder(
        this.email,
        this.orderCode,
        this.slug
      );

      if (response.data) {
        this.order = response.data;
        if (this.order?.listSelectedProductId?.length) {
          for (let item of this.order.listSelectedProductId) {
            let listVariant = {};
            if (item.listValue.length) {
              const listValue = item.listValue;
              const listOption = item.listOption || [];
              for (let val of listValue) {
                const findOption = listOption.find((elem: any) =>
                  elem.values.includes(val)
                );
                if (findOption) {
                  //@ts-ignore
                  listVariant[`${findOption.name}`] = val;
                }
              }
            }
            item["listVariant"] = listVariant;
          }
        }
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.siteInfoModule.setLoadingFullPage(false);
    }
  }

  convertImage(product: any) {
    if (product.imageUrl) {
      return `${api}/${product.imageUrl}`;
    }
    return "";
  }
}
</script>

<style src="./style.css"></style>
